<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-success px-3 py-2" (click)="newRow(); openModal(modal, 'Tipos de Notas');">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button class="btn btn-danger ml-1 px-4 py-2" (click)="printPDF()">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
    <div class="card-body">

      <div *ngIf="!loading">

        <kendo-grid [data]="dataGrid"
                    [filter]="filter"
                    [filterable]="true"
                    (filterChange)="filterChange($event)"
                    [selectable]="true"
                    [navigable]="true"
                    [reorderable]="true"
                    [resizable]="true"
                    [sort]="sort"
                    [sortable]="true"
                    (sortChange)="sortChange($event)"
                    [groupable]="true"
                    [group]="groups"
                    (groupChange)="groupChange($event)"
                    (edit)="editRow($event); openModal(modal, 'Tipos de Notas')"
                    (remove)="deleteRow($event)"
                    style="height: 69vh">
            <div *ngFor="let item of gridFields">
                <kendo-grid-column [field]="item.field" [title]="item.title" [width]="item.width"
                                   [filterable]="item.filtro"></kendo-grid-column>
            </div>
            <kendo-grid-column field="thist" title="Historico" width="120">
              <ng-template kendoGridCellTemplate let-dataItem>
                {{dataItem.thist ? 'Si' : 'No'}}
              </ng-template>
            </kendo-grid-column>
            <kendo-grid-column field="ttr" title="Reg" width="100">
              <ng-template kendoGridCellTemplate let-dataItem>
                {{dataItem.ttr ? 'Si' : 'No'}}
              </ng-template>
            </kendo-grid-column>
            <kendo-grid-column field="tmmanual" title="Res/Rec" width="120"></kendo-grid-column>
            <kendo-grid-column field="Predeterminado" title="Pred." width="100">
              <ng-template kendoGridCellTemplate let-dataItem>
                {{dataItem.Predeterminado ? 'Si' : 'No'}}
              </ng-template>
            </kendo-grid-column>
            <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
                <ng-template kendoGridFilterCellTemplate>
                    <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
                    </kendo-switch>
                </ng-template>
                <ng-template kendoGridCellTemplate let-dataItem>
                    <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
                </ng-template>
            </kendo-grid-column>
            <kendo-grid-command-column title="Actions" width="220">
                <ng-template kendoGridCellTemplate let-isNew="isNew">
                    <button kendoGridEditCommand [primary]="true">Editar</button>
                    <button kendoGridRemoveCommand>Eliminar</button>
                </ng-template>
            </kendo-grid-command-column>
        </kendo-grid>

      </div>


    </div>
    <app-loading *ngIf="loading"></app-loading>
</div>


<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row" *ngIf="flagShowForm">
            <form [formGroup]="myFormGroup">
                <div class="row">
                    <div class="col-6">
                        <label for="tnota">T.N.</label>
                        <input type="text" class="form-control" name="tnota" maxlength="2" minlength="1"
                               [(ngModel)]="myFormGroup.value.tnota"
                               autofocus formControlName="tnota" [readOnly]="flagEdit"
                               pattern="[a-zA-Z0-9]*">
                    </div>
                    <div class="ml-4 col-4">
                        <label for="Inactivo">Inactivo</label>
                        <kendo-switch name="Inactivo" [(ngModel)]="myFormGroup.value.Inactivo"
                                      formControlName="Inactivo"
                                      [onLabel]="'Si'" [offLabel]="'No'">
                        </kendo-switch>
                    </div>
                    <div class="col-12">
                        <label class="mt-1" for="tdesc">Descripción</label>
                        <input type="text" class="form-control" name="tdesc"
                               [(ngModel)]="myFormGroup.value.tdesc"
                               formControlName="tdesc"
                               maxlength="30" pattern="[a-zA-Z0-9 ]*">
                    </div>
                    <div class="col-6">
                        <label for="thist" class="mt-1 w-100">Historico</label>
                        <kendo-switch name="thist" [(ngModel)]="myFormGroup.value.thist"
                                      formControlName="thist"
                                      [onLabel]="'Si'" [offLabel]="'No'">
                        </kendo-switch>
                    </div>
                    <div class="col-6">
                        <label for="ttr" class="mt-1 w-100">Reg.</label>
                        <kendo-switch name="ttr" [(ngModel)]="myFormGroup.value.ttr"
                                      formControlName="ttr"
                                      [onLabel]="'Si'" [offLabel]="'No'">
                        </kendo-switch>
                    </div>
                    <div class="col-6">
                        <label for="Predeterminado" class="mt-1 w-100">Predeterminado</label>
                        <kendo-switch name="Predeterminado"
                                      [(ngModel)]="myFormGroup.value.Predeterminado"
                                      formControlName="Predeterminado"
                                      [onLabel]="'Si'" [offLabel]="'No'">
                        </kendo-switch>
                    </div>

                </div>
            </form>
    </div>
    <div class="row" *ngIf="flagShowForm">
            <div class="row col-12">
                    <h5 class="w-100">Uso</h5>
                    <div class="col-8 custom-control custom-checkbox" *ngFor="let util of tmmanual;">
                        <input type="checkbox" class="custom-control-input" [id]="util.id" [name]="util.id"
                               [(ngModel)]="util.value">
                        <label class="custom-control-label" [for]="util.id">{{ util.desc }}</label>
                    </div>
            </div>
    </div>
  </div>
  <div class="modal-footer">
    <button class="btn btn-success" (click)="guardarForm(); c();"
    [disabled]="myFormGroup.status === 'INVALID'">
      <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="btn btn-secondary" (click)="cerrarForm(); c('Close click')">Cerrar</button>
  </div>
</ng-template>
